VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "EDErrStd"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'EDErrStd.cls -     

Option Explicit

' IErrorData
Implements IErrorData

' API
Private Declare Function FormatMessage Lib "kernel32.dll" Alias _
"FormatMessageA" ( _
    ByVal dwFlags As Long, _
    ByRef lpSource As Any, _
    ByVal dwMessageId As Long, _
    ByVal dwLanguageId As Long, _
    ByVal lpBuffer As String, _
    ByVal nSize As Long, _
    ByRef Arguments As Long) As Long
    
Private Const FORMAT_MESSAGE_FROM_SYSTEM As Long = &H1000
Private Const FORMAT_MESSAGE_IGNORE_INSERTS As Long = &H200
Private Const FORMAT_MESSAGE_MAX_WIDTH_MASK As Long = &HFF

' 
Private m_Kind As EEKind
Private m_Status As EEStatus
Private m_Number As Long
Private m_Description As String

Private Sub IErrorData_Clear()
    m_Kind = kdVB
    m_Status = stNormal
    m_Number = 0
    m_Description = vbNullString
End Sub

Public Property Get IErrorData_Number() As Long
    IErrorData_Number = m_Number
End Property

Public Property Let IErrorData_Number(Value As Long)
    m_Number = Value
End Property

Public Property Get IErrorData_Description() As String
    IErrorData_Description = m_Description
End Property

Public Property Let IErrorData_Description(Value As String)
    m_Description = Value
    If m_Kind = kdAPI And Len(m_Description) = 0 Then
        m_Description = FmtErrorMsg(m_Number)
    End If
End Property

Public Property Get IErrorData_Kind() As EEKind
    IErrorData_Kind = m_Kind
End Property

Public Property Let IErrorData_Kind(Value As EEKind)
    m_Kind = Value
End Property

Public Property Get IErrorData_Status() As EEStatus
    IErrorData_Status = m_Status
End Property

Public Property Let IErrorData_Status(Value As EEStatus)
    m_Status = Value
End Property

Private Function FmtErrorMsg(ByVal DllError As Long) As String

    Dim strBuff As String * 257
    Dim lngRc As Long
  
    lngRc = FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM Or _
        FORMAT_MESSAGE_IGNORE_INSERTS Or FORMAT_MESSAGE_MAX_WIDTH_MASK, 0&, _
        DllError, 0&, strBuff, 256&, 0&)
        
    If (lngRc = 0) Then
        FmtErrorMsg = vbNullString
    Else
        FmtErrorMsg = Left$(strBuff, lngRc - 1)
    End If

End Function


