VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CFile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'///////////////////////////////////////////////////////////////////////////////
'/                                  CFile.cls                                  /
'/                        (API)                   /
'///////////////////////////////////////////////////////////////////////////////
'/                                                : 12.02.2005 ., hCORe /
'/                                               : 14.11.2005 ., hCORe /
'/                                                               : 0.8.0 /
'///////////////////////////////////////////////////////////////////////////////

'    -  "hCORe" 
'    .

'     - ! ;)


'   (: + , - ,
' ~ , #  ):

' 0.8.0
'  ~     InputToDelim
'      

' 0.7.5
'  + :  OpenFile   
'        128 ,  CreateFile
'  ~  

' 0.6.0
'  +      -""
'  + ,  %)
'  # -  InputToDelim - 
'       

' 0.4.0c
'  #  -

' 0.4.0
'  +     (,  , )

' 0.2.0
'  + , , ,  

' 0.1.0
'  +   

'///////////////////////////////////////////////////////////////////////////////////

'  VB-
Option Explicit

' 

' 
Private m_FileName As String
'    
Private m_FormatCase As Boolean
'/ 
Private m_CaseType As CFileCaseTypes
'   
Private m_Confirm As Boolean
'    
Private m_Overwrite As Boolean
'""    (  )
Private m_Attach As IFileAccessError
Private m_Nfo As IErrorData

'  
Public Enum CFileCaseTypes
    CASE_TYPE_UPPER = &H7050
    CASE_TYPE_LOWER = &H7060
End Enum

'  
Public Enum CFileAttributes
    FILE_ATTRIBUTE_HIDDEN = &H20
    FILE_ATTRIBUTE_COMPRESSED = &H800
    FILE_ATTRIBUTE_DEVICE = &H40
    FILE_ATTRIBUTE_DIRECTORY = &H10
    FILE_ATTRIBUTE_ENCRYPTED = &H4000
    FILE_ATTRIBUTE_ARCHIVE = &H2
    FILE_ATTRIBUTE_NORMAL = &H80
    FILE_ATTRIBUTE_NOT_CONTENT_INDEXED = &H2000
    FILE_ATTRIBUTE_OFFLINE = &H1000
    FILE_ATTRIBUTE_READONLY = &H1
    FILE_ATTRIBUTE_REPARSE_POINT = &H400
    FILE_ATTRIBUTE_SPARSE_FILE = &H200
    FILE_ATTRIBUTE_SYSTEM = &H4
    FILE_ATTRIBUTE_TEMPORARY = &H100
End Enum

'API-

Private Declare Function GetCurrentDirectory Lib "kernel32" _
Alias "GetCurrentDirectoryA" ( _
    ByVal nBufferLength As Long, _
    ByVal lpBuffer As String) As Long

Private Declare Function SHFileOperation Lib "shell32.dll" _
Alias "SHFileOperationA" ( _
    lpFileOp As SHFILEOPSTRUCT) As Long

Private Declare Sub CopyMemory Lib "kernel32.dll" _
Alias "RtlMoveMemory" ( _
    ByVal Destination As Any, _
    Source As Any, _
    ByVal Length As Long)
    
Private Declare Sub CopyMemoryRef Lib "kernel32.dll" _
Alias "RtlMoveMemory" ( _
    Destination As Any, _
    ByVal Source As Any, _
    ByVal Length As Long)
    
Private Declare Function GetFileSize Lib "kernel32" ( _
    ByVal hFile As Long, _
    lpFileSizeHigh As Long) As Long
    
Private Declare Function GetFileTime Lib "kernel32" ( _
    ByVal hFile As Long, _
    lpCreationTime As FILETIME, _
    lpLastAccessTime As FILETIME, _
    lpLastWriteTime As FILETIME) As Long
Private Declare Function FileTimeToSystemTime Lib "kernel32" ( _
    lpFileTime As FILETIME, _
    lpSystemTime As SYSTEMTIME) As Long
Private Declare Function FileTimeToLocalFileTime Lib "kernel32" ( _
    lpFileTime As FILETIME, _
    lpLocalFileTime As FILETIME) As Long
Private Declare Function SystemTimeToFileTime Lib "kernel32.dll" ( _
    ByRef lpSystemTime As SYSTEMTIME, _
    ByRef lpFileTime As FILETIME) As Long
Private Declare Function LocalFileTimeToFileTime Lib "kernel32.dll" ( _
    ByRef lpLocalFileTime As FILETIME, _
    ByRef lpFileTime As FILETIME) As Long
Private Declare Function SetFileTime Lib "kernel32" ( _
    ByVal hFile As Long, _
    lpCreationTime As FILETIME, _
    lpLastAccessTime As FILETIME, _
    lpLastWriteTime As FILETIME) As Long
    
Private Declare Function SetFileAttributes Lib "kernel32" _
Alias "SetFileAttributesA" ( _
    ByVal lpFileName As String, _
    ByVal dwFileAttributes As Long) As Long
    
Private Declare Function GetFileAttributes Lib "kernel32" _
Alias "GetFileAttributesA" ( _
    ByVal lpFileName As String) As Long

Private Declare Function ReadFile Lib "kernel32" ( _
    ByVal hFile As Long, _
    lpBuffer As Any, _
    ByVal nNumberOfBytesToRead As Long, _
    lpNumberOfBytesRead As Long, _
    ByVal lpOverlapped As Any) As Long
Private Declare Function CloseHandle Lib "kernel32" ( _
    ByVal hObject As Long) As Long

Private Declare Function CreateFile Lib "kernel32.dll" Alias "CreateFileA" ( _
     ByVal lpFileName As String, _
     ByVal dwDesiredAccess As Long, _
     ByVal dwShareMode As Long, _
     ByRef lpSecurityAttributes As Long, _
     ByVal dwCreationDisposition As Long, _
     ByVal dwFlagsAndAttributes As Long, _
     ByVal hTemplateFile As Long) As Long
Private Declare Function SetFilePointer Lib "kernel32.dll" ( _
     ByVal hFile As Long, _
     ByVal lDistanceToMove As Long, _
     ByRef lpDistanceToMoveHigh As Long, _
     ByVal dwMoveMethod As Long) As Long
Private Declare Function WriteFile Lib "kernel32.dll" ( _
     ByVal hFile As Long, _
     ByRef lpBuffer As Any, _
     ByVal nNumberOfBytesToWrite As Long, _
     ByRef lpNumberOfBytesWritten As Long, _
     ByRef lpOverlapped As Long) As Long
    
'   
Private Const FILE_BEGIN As Long = 0
Private Const FILE_END As Long = 2

' 
Private Const OFS_MAXPATHNAME = 128

'   
Private Const CREATE_ALWAYS As Long = 2
Private Const GENERIC_READ As Long = &H80000000
Private Const GENERIC_WRITE = &H40000000
Private Const OPEN_EXISTING As Long = 3
Private Const FILE_SHARE_READ = &H1
Private Const FILE_SHARE_WRITE = &H2

'    
Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

'    
Private Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

' SHOp
Private Type SHFILEOPSTRUCT
    hWnd As Long
    wFunc As Long
    pFrom As String
    pTo As String
    fFlags As Integer
    fAborted As Boolean
    hNameMaps As Long
    sProgress As String
End Type

'
Private Const FO_COPY As Long = &H2
Private Const FO_DELETE As Long = &H3
Private Const FO_MOVE As Long = &H1
Private Const FO_RENAME As Long = &H4

' SHOp
Private Const FOF_ALLOWUNDO As Long = &H40
Private Const FOF_MULTIDESTFILES As Long = &H1
Private Const FOF_NOCONFIRMATION As Long = &H10
Private Const FOF_NOERRORUI As Long = &H400
Private Const FOF_SILENT As Long = &H4

'  & 

'  - 

' VB  API?
Private Function IsVBErr() As Boolean
    If Err.Number <> 0 Then IsVBErr = True
End Function

'  IErrorData ?
Private Function CheckNfo() As Boolean
    CheckNfo = Not (m_Nfo Is Nothing)
    If Not (m_Nfo Is Nothing) Then m_Nfo.Clear
End Function

'  IFileAccessError ?
Private Function CheckAttach() As Boolean
    CheckAttach = Not (m_Attach Is Nothing)
End Function

' ?
Private Function CheckError() As Boolean
    CheckError = (Err.LastDllError <> 0) Or (Err.Number <> 0)
End Function

'     
Private Sub InputBytes(Actual As String, Pos As Long, ByteCount As Long, arr() As Byte)
On Error Resume Next
    Dim hFile As Long
    Dim arrBytes(0) As Byte
    Dim lSize As Long, lRet As Long
      
    ' 
    
    Err.Clear

    hFile = CreateFile(Actual, GENERIC_READ, FILE_SHARE_READ Or _
    FILE_SHARE_WRITE, ByVal 0&, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, ByVal 0&)

    'If hFile = -1 Then Exit Sub
    lSize = GetFileSize(hFile, 0)
    'If lSize = -1 Then Exit Sub
    SetFilePointer hFile, Pos, 0, FILE_BEGIN

    ReadFile hFile, arr(0), ByteCount, lRet, ByVal 0&
    CloseHandle hFile
    
    If CheckError And CheckAttach And CheckNfo Then
        m_Nfo.Status = stErr
        m_Nfo.Kind = IIf(IsVBErr, kdVB, kdApi)
        m_Nfo.Number = IIf(m_Nfo.Kind = kdApi, Err.LastDllError, Err.Number)
        m_Nfo.Description = Err.Description
        m_Attach.SetErrorInfo m_Nfo
        Err.Clear
    End If

End Sub

' 1    
Private Function InputByte(Actual As String, Pos As Long) As Byte
On Error Resume Next
    Dim hFile As Long
    Dim arrBytes(0) As Byte
    Dim lSize As Long, lRet As Long
      
    ' 
    
    Err.Clear

    hFile = CreateFile(Actual, GENERIC_READ, FILE_SHARE_READ Or _
    FILE_SHARE_WRITE, ByVal 0&, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, ByVal 0&)

    'If hFile = -1 Then Exit Function
    lSize = GetFileSize(hFile, 0)
    'If lSize = -1 Then Exit Function
    SetFilePointer hFile, Pos, 0, FILE_BEGIN

    ReadFile hFile, arrBytes(0), 1, lRet, ByVal 0&
    CloseHandle hFile
    
    InputByte = arrBytes(0)
    
    If CheckError And CheckAttach And CheckNfo Then
        m_Nfo.Status = stErr
        m_Nfo.Kind = IIf(IsVBErr, kdVB, kdApi)
        m_Nfo.Number = IIf(m_Nfo.Kind = kdApi, Err.LastDllError, Err.Number)
        m_Nfo.Description = Err.Description
        m_Attach.SetErrorInfo m_Nfo
        Err.Clear
    End If
    
End Function

'    VB
Private Function InputToStr(Actual As String) As String
On Error Resume Next
    Dim hFile As Long
    Dim arrBytes() As Byte
    Dim lSize As Long, lRet As Long

    Err.Clear
    
    ' 
    
    hFile = CreateFile(Actual, GENERIC_READ, FILE_SHARE_READ Or _
    FILE_SHARE_WRITE, ByVal 0&, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, ByVal 0&)
    
    'If hFile = -1 Then Exit Function
    lSize = GetFileSize(hFile, 0)
    'If lSize = -1 Then Exit Function
    ReDim arrBytes(lSize)
    ReadFile hFile, arrBytes(0), UBound(arrBytes), lRet, ByVal 0&
    
    ' 
    CloseHandle hFile
    
    If CheckError And CheckAttach And CheckNfo Then
        m_Nfo.Status = stErr
        m_Nfo.Kind = IIf(IsVBErr, kdVB, kdApi)
        m_Nfo.Number = IIf(m_Nfo.Kind = kdApi, Err.LastDllError, Err.Number)
        m_Nfo.Description = Err.Description
        m_Attach.SetErrorInfo m_Nfo
        Err.Clear
    End If
    
    Err.Clear
    
    ReDim Preserve arrBytes(UBound(arrBytes) - 1)

    InputToStr = StrConv(CStr(arrBytes), vbUnicode)
    
    If CheckError And CheckAttach And CheckNfo Then
        m_Nfo.Status = stErr
        m_Nfo.Kind = IIf(IsVBErr, kdVB, kdApi)
        m_Nfo.Number = IIf(m_Nfo.Kind = kdApi, Err.LastDllError, Err.Number)
        m_Nfo.Description = Err.Description
        m_Attach.SetErrorInfo m_Nfo
        Err.Clear
    End If

End Function

'    ()
Private Function InputToDelim(Actual As String, Delim As String, Optional DelimCount As Long = 1, Optional StartDelim As Long = 0) As String
On Error Resume Next
    Dim hFile As Long
    Dim sData As String
    Dim sReadByte As String
    Dim lDelimLen As Long
    Dim nDelimsFound As Long
    Dim sExtract As String
    Dim sReadData As String
    
    Err.Clear
    
    hFile = CreateFile(Actual, GENERIC_READ, FILE_SHARE_READ Or _
    FILE_SHARE_WRITE, ByVal 0&, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, _
    ByVal 0&)
    
    lDelimLen = Len(Delim)
    
    Do
        sReadByte = ReadByte(hFile)
        If Len(sReadByte) = 1 Then
            sReadData = sReadData & sReadByte
            
            If nDelimsFound >= StartDelim Then
                sData = sData & sReadByte
            End If
            
            sExtract = vbNullString
            If Len(sReadData) >= lDelimLen Then
                sExtract = Right$(sReadData, lDelimLen)
            End If
            
            If sExtract = Delim Then
                nDelimsFound = nDelimsFound + 1
                If nDelimsFound >= StartDelim + DelimCount And DelimCount <> 0 Then
                    sData = Mid$(sData, 1, Len(sData) - lDelimLen)
                    Exit Do
                End If
            End If
        Else
            Exit Do
        End If
    Loop

    ' 
    CloseHandle hFile
    InputToDelim = sData

    If CheckError And CheckAttach And CheckNfo Then
        m_Nfo.Status = stErr
        m_Nfo.Kind = IIf(IsVBErr, kdVB, kdApi)
        m_Nfo.Number = IIf(m_Nfo.Kind = kdApi, Err.LastDllError, Err.Number)
        m_Nfo.Description = Err.Description
        m_Attach.SetErrorInfo m_Nfo
        Err.Clear
    End If

End Function

' 1      hFile
Private Function ReadByte(hFile As Long) As String
On Error Resume Next
    Dim arrBytes(0) As Byte, lRet As Long, lRt As Long
    
    Err.Clear
    
    lRt = ReadFile(hFile, arrBytes(0), 1, lRet, ByVal 0&)
    If lRt <> 0 And lRet <> 0 Then
        ReadByte = Chr(arrBytes(0))
    Else
        ReadByte = "##"
    End If
    
    Err.Clear
    
End Function


' 

'
Private Sub Class_Initialize()
    m_FormatCase = True
    m_CaseType = CASE_TYPE_UPPER
    m_Confirm = False
    m_Overwrite = True
End Sub

' 

' IFileAccessError, IErrorData
Public Sub E_Attach(Atch As IFileAccessError, Nfo As IErrorData)
    Set m_Attach = Atch
    Set m_Nfo = Nfo
End Sub

'  
Public Sub E_Detach()
    Set m_Attach = Nothing
    Set m_Nfo = Nothing
End Sub

'
Public Property Get P_Attributes() As CFileAttributes
    Err.Clear
    
    P_Attributes = GetFileAttributes(m_FileName)
    
    If CheckError And CheckAttach And CheckNfo Then
        m_Nfo.Status = stErr
        m_Nfo.Kind = IIf(IsVBErr, kdVB, kdApi)
        m_Nfo.Number = IIf(m_Nfo.Kind = kdApi, Err.LastDllError, Err.Number)
        m_Nfo.Description = Err.Description
        m_Attach.SetErrorInfo m_Nfo
        Err.Clear
    End If
End Property

Public Property Let P_Attributes(Value As CFileAttributes)
    Err.Clear
    
    SetFileAttributes m_FileName, Value
    
    If CheckError And CheckAttach And CheckNfo Then
        m_Nfo.Status = stErr
        m_Nfo.Kind = IIf(IsVBErr, kdVB, kdApi)
        m_Nfo.Number = IIf(m_Nfo.Kind = kdApi, Err.LastDllError, Err.Number)
        m_Nfo.Description = Err.Description
        m_Attach.SetErrorInfo m_Nfo
        Err.Clear
    End If
End Property

'    ?
Public Property Get P_Overwrite() As Boolean
    P_Overwrite = m_Overwrite
End Property

Public Property Let P_Overwrite(Value As Boolean)
    m_Overwrite = Value
End Property

'  ///
'
Public Property Get P_Confirm() As Boolean
    P_Confirm = m_Confirm
End Property

Public Property Let P_Confirm(Value As Boolean)
    m_Confirm = Value
End Property

' ?
Public Property Get P_FormatCase() As Boolean
    P_FormatCase = m_FormatCase
End Property

Public Property Let P_FormatCase(Value As Boolean)
    m_FormatCase = Value
End Property

'  (/ )
Public Property Get P_CaseType() As CFileCaseTypes
    P_CaseType = m_CaseType
End Property

Public Property Let P_CaseType(Value As CFileCaseTypes)
    m_CaseType = Value
End Property

' 
Public Property Get P_CreationDate() As Date
On Error Resume Next
    Dim hFile As Long
    
    Err.Clear
    
    hFile = CreateFile(m_FileName, GENERIC_READ, FILE_SHARE_READ Or _
    FILE_SHARE_WRITE, ByVal 0&, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, ByVal 0&)

    'If hFile = -1 Then Exit Property
    
    Dim Ft1 As FILETIME, Ft2 As FILETIME, _
    Ft3 As FILETIME, Ft4 As FILETIME, SysTime As SYSTEMTIME
    GetFileTime hFile, Ft1, Ft2, Ft3
    FileTimeToLocalFileTime Ft1, Ft4
    FileTimeToSystemTime Ft4, SysTime
    
    Dim sDate As String
    sDate = Trim$(SysTime.wMonth) & "/" & Trim$(SysTime.wDay) & "/" & _
    Trim$(SysTime.wYear) & " " & Trim$(SysTime.wHour) & ":" & _
    Trim$(SysTime.wMinute) & ":" & Trim$(SysTime.wSecond)
    P_CreationDate = CDate(sDate)
    
    If CheckError And CheckAttach And CheckNfo Then
        m_Nfo.Status = stErr
        m_Nfo.Kind = IIf(IsVBErr, kdVB, kdApi)
        m_Nfo.Number = IIf(m_Nfo.Kind = kdApi, Err.LastDllError, Err.Number)
        m_Nfo.Description = Err.Description
        m_Attach.SetErrorInfo m_Nfo
        Err.Clear
    End If
    
End Property

Public Property Let P_CreationDate(Value As Date)
On Error Resume Next
    Dim udtSystemTime As SYSTEMTIME
    Dim udtLocalTime As FILETIME
    Dim udtFileTime As FILETIME
    
    Dim hFile As Long
    
    Err.Clear
    
    hFile = CreateFile(m_FileName, GENERIC_READ Or GENERIC_WRITE, _
    FILE_SHARE_READ Or FILE_SHARE_WRITE, ByVal 0&, OPEN_EXISTING, _
    FILE_ATTRIBUTE_NORMAL, ByVal 0&)

    'If hFile = -1 Then Exit Property
    
    udtSystemTime.wYear = Year(Value)
    udtSystemTime.wMonth = Month(Value)
    udtSystemTime.wDay = Day(Value)
    udtSystemTime.wDayOfWeek = Weekday(Value) - 1
    udtSystemTime.wHour = Hour(Value)
    udtSystemTime.wMinute = Minute(Value)
    udtSystemTime.wSecond = Second(Value)
    udtSystemTime.wMilliseconds = 0

    SystemTimeToFileTime udtSystemTime, udtLocalTime
    LocalFileTimeToFileTime udtLocalTime, udtFileTime
    
    Dim udtF As FILETIME, udtF2 As FILETIME, udtF3 As FILETIME
    
    GetFileTime hFile, udtF, udtF2, udtF3
    
    SetFileTime hFile, udtFileTime, udtF2, udtF3
    
    CloseHandle hFile
    
    If CheckError And CheckAttach And CheckNfo Then
        m_Nfo.Status = stErr
        m_Nfo.Kind = IIf(IsVBErr, kdVB, kdApi)
        m_Nfo.Number = IIf(m_Nfo.Kind = kdApi, Err.LastDllError, Err.Number)
        m_Nfo.Description = Err.Description
        m_Attach.SetErrorInfo m_Nfo
        Err.Clear
    End If
    
End Property

'  
Public Property Get P_LastAccessDate() As Date
On Error Resume Next
    Dim hFile As Long
    
    Err.Clear
    
    hFile = CreateFile(m_FileName, GENERIC_READ, _
    FILE_SHARE_READ Or FILE_SHARE_WRITE, ByVal 0&, OPEN_EXISTING, _
    FILE_ATTRIBUTE_NORMAL, ByVal 0&)
    
    'If hFile = -1 Then Exit Property
    Dim Ft1 As FILETIME, Ft2 As FILETIME, _
    Ft3 As FILETIME, Ft4 As FILETIME, SysTime As SYSTEMTIME
    GetFileTime hFile, Ft1, Ft2, Ft3
    FileTimeToLocalFileTime Ft2, Ft4
    FileTimeToSystemTime Ft4, SysTime
    
    Dim sDate As String
    sDate = Trim$(SysTime.wMonth) & "/" & Trim$(SysTime.wDay) & "/" & _
    Trim$(SysTime.wYear) & " " & Trim$(SysTime.wHour) & ":" & _
    Trim$(SysTime.wMinute) & ":" & Trim$(SysTime.wSecond)
    P_LastAccessDate = CDate(sDate)
    
    If CheckError And CheckAttach And CheckNfo Then
        m_Nfo.Status = stErr
        m_Nfo.Kind = IIf(IsVBErr, kdVB, kdApi)
        m_Nfo.Number = IIf(m_Nfo.Kind = kdApi, Err.LastDllError, Err.Number)
        m_Nfo.Description = Err.Description
        m_Attach.SetErrorInfo m_Nfo
        Err.Clear
    End If
End Property

Public Property Let P_LastAccessDate(Value As Date)
On Error Resume Next
    Dim udtSystemTime As SYSTEMTIME
    Dim udtLocalTime As FILETIME
    Dim udtFileTime As FILETIME
    
    Dim hFile As Long
    
    Err.Clear
    
    hFile = CreateFile(m_FileName, GENERIC_READ Or GENERIC_WRITE, _
    FILE_SHARE_READ Or FILE_SHARE_WRITE, ByVal 0&, OPEN_EXISTING, _
    FILE_ATTRIBUTE_NORMAL, ByVal 0&)
    
    'If hFile = -1 Then Exit Property
    
    udtSystemTime.wYear = Year(Value)
    udtSystemTime.wMonth = Month(Value)
    udtSystemTime.wDay = Day(Value)
    udtSystemTime.wDayOfWeek = Weekday(Value) - 1
    udtSystemTime.wHour = Hour(Value)
    udtSystemTime.wMinute = Minute(Value)
    udtSystemTime.wSecond = Second(Value)
    udtSystemTime.wMilliseconds = 0

    SystemTimeToFileTime udtSystemTime, udtLocalTime
    LocalFileTimeToFileTime udtLocalTime, udtFileTime
    
    Dim udtF As FILETIME, udtF2 As FILETIME, udtF3 As FILETIME
    
    GetFileTime hFile, udtF, udtF2, udtF3
    
    SetFileTime hFile, udtF, udtFileTime, udtF3
    
    CloseHandle hFile
    
    If CheckError And CheckAttach And CheckNfo Then
        m_Nfo.Status = stErr
        m_Nfo.Kind = IIf(IsVBErr, kdVB, kdApi)
        m_Nfo.Number = IIf(m_Nfo.Kind = kdApi, Err.LastDllError, Err.Number)
        m_Nfo.Description = Err.Description
        m_Attach.SetErrorInfo m_Nfo
        Err.Clear
    End If
    
End Property

'  
Public Property Get P_LastWriteDate() As Date
On Error Resume Next
    Dim hFile As Long
    
    Err.Clear
    
    hFile = CreateFile(m_FileName, GENERIC_READ, _
    FILE_SHARE_READ Or FILE_SHARE_WRITE, ByVal 0&, OPEN_EXISTING, _
    FILE_ATTRIBUTE_NORMAL, ByVal 0&)
    
    'If hFile = -1 Then Exit Property
    Dim Ft1 As FILETIME, Ft2 As FILETIME, _
    Ft3 As FILETIME, Ft4 As FILETIME, SysTime As SYSTEMTIME
    GetFileTime hFile, Ft1, Ft2, Ft3
    FileTimeToLocalFileTime Ft3, Ft4
    FileTimeToSystemTime Ft4, SysTime
    
    Dim sDate As String
    sDate = Trim$(SysTime.wMonth) & "/" & Trim$(SysTime.wDay) & "/" & _
    Trim$(SysTime.wYear) & " " & Trim$(SysTime.wHour) & ":" & _
    Trim$(SysTime.wMinute) & ":" & Trim$(SysTime.wSecond)
    P_LastWriteDate = CDate(sDate)
    
    If CheckError And CheckAttach And CheckNfo Then
        m_Nfo.Status = stErr
        m_Nfo.Kind = IIf(IsVBErr, kdVB, kdApi)
        m_Nfo.Number = IIf(m_Nfo.Kind = kdApi, Err.LastDllError, Err.Number)
        m_Nfo.Description = Err.Description
        m_Attach.SetErrorInfo m_Nfo
        Err.Clear
    End If
    
End Property

Public Property Let P_LastWriteDate(Value As Date)
On Error Resume Next
    Dim udtSystemTime As SYSTEMTIME
    Dim udtLocalTime As FILETIME
    Dim udtFileTime As FILETIME
    
    Dim hFile As Long
    
    Err.Clear
    
    hFile = CreateFile(m_FileName, GENERIC_READ Or GENERIC_WRITE, _
    FILE_SHARE_READ Or FILE_SHARE_WRITE, ByVal 0&, OPEN_EXISTING, _
    FILE_ATTRIBUTE_NORMAL, ByVal 0&)
    
    'If hFile = -1 Then Exit Property
    
    udtSystemTime.wYear = Year(Value)
    udtSystemTime.wMonth = Month(Value)
    udtSystemTime.wDay = Day(Value)
    udtSystemTime.wDayOfWeek = Weekday(Value) - 1
    udtSystemTime.wHour = Hour(Value)
    udtSystemTime.wMinute = Minute(Value)
    udtSystemTime.wSecond = Second(Value)
    udtSystemTime.wMilliseconds = 0

    SystemTimeToFileTime udtSystemTime, udtLocalTime
    LocalFileTimeToFileTime udtLocalTime, udtFileTime
    
    Dim udtF As FILETIME, udtF2 As FILETIME, udtF3 As FILETIME
    
    GetFileTime hFile, udtF, udtF2, udtF3
    
    SetFileTime hFile, udtF, udtF2, udtFileTime
    
    CloseHandle hFile
    
    If CheckError And CheckAttach And CheckNfo Then
        m_Nfo.Status = stErr
        m_Nfo.Kind = IIf(IsVBErr, kdVB, kdApi)
        m_Nfo.Number = IIf(m_Nfo.Kind = kdApi, Err.LastDllError, Err.Number)
        m_Nfo.Description = Err.Description
        m_Attach.SetErrorInfo m_Nfo
        Err.Clear
    End If
    
End Property

' 
Public Property Let P_FileName(Value As String)
    m_FileName = Value
End Property
Public Property Get P_FileName() As String
    P_FileName = m_FileName
End Property


' 
Public Function G_Rename(NewName As String)
    Dim StrC As SHFILEOPSTRUCT, r As Long
    
    Err.Clear
    
    StrC.wFunc = FO_RENAME
    StrC.fFlags = FOF_SILENT
    If m_Confirm = False Then StrC.fFlags = StrC.fFlags Or FOF_NOCONFIRMATION
    StrC.pFrom = m_FileName
    StrC.pTo = NewName
    r = SHFileOperation(StrC)
    
    If CheckError And CheckAttach And CheckNfo Then
        m_Nfo.Status = stErr
        m_Nfo.Kind = IIf(IsVBErr, kdVB, kdApi)
        m_Nfo.Number = IIf(m_Nfo.Kind = kdApi, Err.LastDllError, Err.Number)
        m_Nfo.Description = Err.Description
        m_Attach.SetErrorInfo m_Nfo
        Err.Clear
    End If
End Function

'    
Public Function G_Move(NewPath As String)
    Dim StrC As SHFILEOPSTRUCT, r As Long
    
    Err.Clear
    
    StrC.wFunc = FO_MOVE
    StrC.fFlags = FOF_SILENT
    If m_Confirm = False Then StrC.fFlags = StrC.fFlags Or FOF_NOCONFIRMATION
    StrC.pFrom = m_FileName
    StrC.pTo = NewPath
    r = SHFileOperation(StrC)
    
    If CheckError And CheckAttach And CheckNfo Then
        m_Nfo.Status = stErr
        m_Nfo.Kind = IIf(IsVBErr, kdVB, kdApi)
        m_Nfo.Number = IIf(m_Nfo.Kind = kdApi, Err.LastDllError, Err.Number)
        m_Nfo.Description = Err.Description
        m_Attach.SetErrorInfo m_Nfo
        Err.Clear
    End If
End Function

'  (:   )
Public Sub G_Remove(Optional EnableUndo As Boolean = False)
    Dim StrC As SHFILEOPSTRUCT, r As Long
    
    Err.Clear
    
    StrC.wFunc = FO_DELETE
    StrC.fFlags = FOF_SILENT
    If m_Confirm = False Then StrC.fFlags = StrC.fFlags Or FOF_NOCONFIRMATION
    If EnableUndo Then StrC.fFlags = StrC.fFlags Or FOF_ALLOWUNDO
    StrC.pFrom = m_FileName
    r = SHFileOperation(StrC)
    
    If CheckError And CheckAttach And CheckNfo Then
        m_Nfo.Status = stErr
        m_Nfo.Kind = IIf(IsVBErr, kdVB, kdApi)
        m_Nfo.Number = IIf(m_Nfo.Kind = kdApi, Err.LastDllError, Err.Number)
        m_Nfo.Description = Err.Description
        m_Attach.SetErrorInfo m_Nfo
        Err.Clear
    End If
End Sub

'  ( ,  - *?)
Public Function G_Copy(NewPath As String, Optional MultiOut As Boolean = False)
On Error Resume Next
    Dim StrC As SHFILEOPSTRUCT, r As Long
    
    Err.Clear
    
    StrC.wFunc = FO_COPY
    StrC.fFlags = FOF_SILENT
    If m_Confirm = False Then StrC.fFlags = StrC.fFlags Or FOF_NOCONFIRMATION
    If MultiOut Then StrC.fFlags = StrC.fFlags Or FOF_MULTIDESTFILES
    StrC.pFrom = m_FileName
    StrC.pTo = NewPath
    Err.Clear
    r = SHFileOperation(StrC)
    
    If CheckError And CheckAttach And CheckNfo Then
        m_Nfo.Status = stErr
        m_Nfo.Kind = IIf(IsVBErr, kdVB, kdApi)
        m_Nfo.Number = IIf(m_Nfo.Kind = kdApi, Err.LastDllError, Err.Number)
        m_Nfo.Description = Err.Description
        m_Attach.SetErrorInfo m_Nfo
        Err.Clear
    End If
End Function

'    
Public Function G_AttrAsStr(Optional Delimiter As String = ";") As String
On Error Resume Next
    Dim sAttr As CFileAttributes, s As String
    sAttr = P_Attributes
    If sAttr And FILE_ATTRIBUTE_ARCHIVE Then s = s & Delimiter & CStr(FILE_ATTRIBUTE_ARCHIVE)
    If sAttr And FILE_ATTRIBUTE_COMPRESSED Then s = s & Delimiter & CStr(FILE_ATTRIBUTE_COMPRESSED)
    If sAttr And FILE_ATTRIBUTE_DEVICE Then s = s & Delimiter & CStr(FILE_ATTRIBUTE_DEVICE)
    If sAttr And FILE_ATTRIBUTE_DIRECTORY Then s = s & Delimiter & CStr(FILE_ATTRIBUTE_DIRECTORY)
    If sAttr And FILE_ATTRIBUTE_ENCRYPTED Then s = s & Delimiter & CStr(FILE_ATTRIBUTE_ENCRYPTED)
    If sAttr And FILE_ATTRIBUTE_HIDDEN Then s = s & Delimiter & CStr(FILE_ATTRIBUTE_HIDDEN)
    If sAttr And FILE_ATTRIBUTE_NORMAL Then s = s & Delimiter & CStr(FILE_ATTRIBUTE_NORMAL)
    If sAttr And FILE_ATTRIBUTE_NOT_CONTENT_INDEXED Then s = s & Delimiter & CStr(FILE_ATTRIBUTE_NOT_CONTENT_INDEXED)
    If sAttr And FILE_ATTRIBUTE_OFFLINE Then s = s & Delimiter & CStr(FILE_ATTRIBUTE_OFFLINE)
    If sAttr And FILE_ATTRIBUTE_READONLY Then s = s & Delimiter & CStr(FILE_ATTRIBUTE_READONLY)
    If sAttr And FILE_ATTRIBUTE_REPARSE_POINT Then s = s & Delimiter & CStr(FILE_ATTRIBUTE_REPARSE_POINT)
    If sAttr And FILE_ATTRIBUTE_SPARSE_FILE Then s = s & Delimiter & CStr(FILE_ATTRIBUTE_SPARSE_FILE)
    If sAttr And FILE_ATTRIBUTE_SYSTEM Then s = s & Delimiter & CStr(FILE_ATTRIBUTE_SYSTEM)
    If sAttr And FILE_ATTRIBUTE_TEMPORARY Then s = s & Delimiter & CStr(FILE_ATTRIBUTE_TEMPORARY)
    
    If Len(s) > 0 Then s = Mid(s, 2)
    G_AttrAsStr = s
End Function

'    
Public Function G_FilePathRoot() As String
On Error Resume Next
    Dim l As Long, s As String, f As Long
    Dim mFileName As String
    
    Err.Clear
    
    mFileName = G_FullPath
    
    f = 1
    l = InStr(1, mFileName, "\")
    If l = 0 Then l = InStr(1, mFileName, "/")
    
    s = Mid$(mFileName, f, l - 1)
    If Len(s) = 0 Then
        'UNC
        If Mid(mFileName, 1, 2) = "\\" Or Mid(mFileName, 1, 2) = "//" Then
            f = f + 2
            l = InStr(f, mFileName, "\")
            If l = 0 Then l = InStr(f, mFileName, "/")
            l = l - 2
        End If
    End If
    
    If m_FormatCase Then
        If m_CaseType = CASE_TYPE_UPPER Then
            G_FilePathRoot = UCase$(Mid$(mFileName, f, l - 1))
        ElseIf m_CaseType = CASE_TYPE_LOWER Then
            G_FilePathRoot = LCase$(Mid$(mFileName, f, l - 1))
        End If
    Else
        G_FilePathRoot = Mid$(mFileName, 1, l - 1)
    End If
    
    If CheckError And CheckAttach And CheckNfo Then
        m_Nfo.Status = stErr
        m_Nfo.Kind = IIf(IsVBErr, kdVB, kdApi)
        m_Nfo.Number = IIf(m_Nfo.Kind = kdApi, Err.LastDllError, Err.Number)
        m_Nfo.Description = Err.Description
        m_Attach.SetErrorInfo m_Nfo
        Err.Clear
    End If
End Function

'  
Public Function G_FullPath() As String
On Error Resume Next
    Dim sPath As String, lBuf As Long, sMid As String
    Dim sRes As String
    
    Err.Clear
    
    sMid = Mid$(m_FileName, 1, 2)
    If sMid = "\\" Or Mid$(sMid, 2, 1) = ":" Then _
    G_FullPath = m_FileName: Exit Function
    
    sPath = String$(1, 0)
    lBuf = GetCurrentDirectory(1, sPath)
    sPath = String$(lBuf, 0)
    GetCurrentDirectory lBuf, sPath
    
    sPath = Mid$(sPath, 1, Len(sPath) - 1)
    
    If Right$(sPath, 1) = "\" Then sPath = Mid$(sPath, 1, Len(sPath) - 1)
    
    sRes = sPath & "\" & m_FileName
    
    If m_FormatCase Then
        If m_CaseType = CASE_TYPE_UPPER Then
            G_FullPath = UCase$(sRes)
        ElseIf m_CaseType = CASE_TYPE_LOWER Then
            G_FullPath = LCase$(sRes)
        End If
    Else
        G_FullPath = sRes
    End If
    
    If CheckError And CheckAttach And CheckNfo Then
        m_Nfo.Status = stErr
        m_Nfo.Kind = IIf(IsVBErr, kdVB, kdApi)
        m_Nfo.Number = IIf(m_Nfo.Kind = kdApi, Err.LastDllError, Err.Number)
        m_Nfo.Description = Err.Description
        m_Attach.SetErrorInfo m_Nfo
        Err.Clear
    End If
End Function

'     (0 - , 1 - 1 ...)
Public Function G_FilePath(RootIndex As Long) As String
On Error Resume Next
    Dim lC As Long, lX As Long, lOx As Long
    Dim lPc As Long
    Dim roots() As String
    ReDim roots(9)
    
    Err.Clear
    
    If RootIndex = 0 Then G_FilePath = G_FilePathRoot: Exit Function
    Dim mFileName As String
    mFileName = G_FullPath
    lX = InStr(1, mFileName, G_FilePathRoot) + Len(G_FilePathRoot)
    Do
        DoEvents
        lX = InStr(lX + 1, G_FullPath, "\")
        If lX = lOx Then Exit Do
        If lX = 0 Then lX = InStr(lX + 1, mFileName, "/")
        If lX = 0 Then
            Exit Do
        Else
            If lOx <> 0 Then
                lPc = lPc + 1
                If lPc > 10 Then ReDim roots(UBound(roots) + 1)
                roots(lPc - 1) = Mid$(mFileName, lOx + 1, lX - lOx - 1)
            End If
        End If
        lOx = lX
    Loop
    lPc = lPc + 1
    If lPc > 10 Then ReDim roots(UBound(roots) + 1)
    roots(lPc - 1) = Mid$(mFileName, lOx + 1)
    If m_FormatCase Then
        If m_CaseType = CASE_TYPE_UPPER Then
            G_FilePath = UCase$(roots(RootIndex - 1))
        ElseIf m_CaseType = CASE_TYPE_LOWER Then
            G_FilePath = LCase$(roots(RootIndex - 1))
        End If
    Else
        G_FilePath = roots(RootIndex - 1)
    End If
    Erase roots

    If CheckError And CheckAttach And CheckNfo Then
        m_Nfo.Status = stErr
        m_Nfo.Kind = IIf(IsVBErr, kdVB, kdApi)
        m_Nfo.Number = IIf(m_Nfo.Kind = kdApi, Err.LastDllError, Err.Number)
        m_Nfo.Description = Err.Description
        m_Attach.SetErrorInfo m_Nfo
        Err.Clear
    End If
End Function

'  
Public Function G_FileExt() As String
On Error Resume Next
    Dim mFileName As String, sDt As String
    
    Err.Clear
    
    mFileName = G_FullPath
    If m_FormatCase Then
        If m_CaseType = CASE_TYPE_UPPER Then
            G_FileExt = UCase$(Mid$(mFileName, InStrRev(mFileName, ".") + 1))
        ElseIf m_CaseType = CASE_TYPE_LOWER Then
            G_FileExt = LCase$(Mid$(mFileName, InStrRev(mFileName, ".") + 1))
        End If
    Else
        G_FileExt = Mid$(mFileName, InStrRev(mFileName, ".") + 1)
    End If

    If CheckError And CheckAttach And CheckNfo Then
        m_Nfo.Status = stErr
        m_Nfo.Kind = IIf(IsVBErr, kdVB, kdApi)
        m_Nfo.Number = IIf(m_Nfo.Kind = kdApi, Err.LastDllError, Err.Number)
        m_Nfo.Description = Err.Description
        m_Attach.SetErrorInfo m_Nfo
        Err.Clear
    End If
End Function

'       VB
Public Function I_All() As String
On Error Resume Next
    I_All = InputToStr(m_FileName)
End Function

'  
' -   StartLine
' -   LineCount
Public Function I_Lines(Optional StartLine As Long = 1, Optional LineCount As Long = 0) As String
On Error Resume Next
    I_Lines = InputToDelim(m_FileName, vbNewLine, LineCount, StartLine - 1)
End Function

'  ,  
Public Function I_Length() As Long
On Error Resume Next
    Dim hFile As Long
    
    Err.Clear
    
    ' 
    hFile = CreateFile(m_FileName, GENERIC_READ, _
    FILE_SHARE_READ Or FILE_SHARE_WRITE, ByVal 0&, OPEN_EXISTING, _
    FILE_ATTRIBUTE_NORMAL, ByVal 0&)
    'If hFile = -1 Then Exit Function
    I_Length = GetFileSize(hFile, 0)
    CloseHandle hFile
    
    If CheckError And CheckAttach And CheckNfo Then
        m_Nfo.Status = stErr
        m_Nfo.Kind = IIf(IsVBErr, kdVB, kdApi)
        m_Nfo.Number = IIf(m_Nfo.Kind = kdApi, Err.LastDllError, Err.Number)
        m_Nfo.Description = Err.Description
        m_Attach.SetErrorInfo m_Nfo
        Err.Clear
    End If
    
End Function

' 1    SeekPos
Public Function I_Byte(SeekPos As Long) As Byte
On Error Resume Next
    I_Byte = InputByte(m_FileName, SeekPos)
End Function

' ByteCount    SeekPos   
Public Function I_BytesAsStr(SeekPos As Long, Optional ByteCount As Long = 0) As String
On Error Resume Next
    Dim l As Long
    Dim arr() As Byte
    If ByteCount = 0 Then ByteCount = I_Length - SeekPos
    ReDim arr(ByteCount - 1)
    InputBytes m_FileName, SeekPos, ByteCount, arr
    I_BytesAsStr = StrConv(arr, vbUnicode)
End Function

' ByteCount    SeekPos    
Public Sub I_BytesAsArr(SeekPos As Long, arr() As Byte, Optional ByteCount As Long = 0)
On Error Resume Next
    Dim l As Long
    If ByteCount = 0 Then ByteCount = I_Length - SeekPos
    InputBytes m_FileName, SeekPos, ByteCount, arr
End Sub

' ByteCount    SeekPos   
'!
'StructAddr __   VarPtr(_)
'ByteCount __  Len(_) - 
'  
Public Sub I_BytesAsStruct(SeekPos As Long, StructAddr As Long, Optional ByteCount As Long = 0)
On Error Resume Next
    Dim l As Long
    Dim arr() As Byte
    If ByteCount = 0 Then ByteCount = I_Length - SeekPos
    ReDim arr(ByteCount - 1)
    InputBytes m_FileName, SeekPos, ByteCount, arr
    CopyMemory StructAddr, arr(0), ByteCount
End Sub

'    Substr  ,
'  SeekStart.   Compare.
Public Function I_Pos(SeekStart As Long, Substr As String, _
Compare As VbCompareMethod) As Long
On Error Resume Next
    Dim s As String, l As Long, oS As String, f As Long
    s = vbNullString
    I_Pos = -1
    Do
        DoEvents
        f = f + 1
        If f > SeekStart + I_Length Then Exit Function
        s = s & Chr(InputByte(m_FileName, SeekStart + f - 1))
        l = InStr(1, s, Substr, Compare)
        If l > 0 Then
            I_Pos = l
            Exit Function
        End If
        oS = s
    Loop
End Function

'   OutData     PosFrom
'  [append]     
'  P_Overwrite = False
Public Function O_All(OutData As String, Optional PosFrom As Long = -1)
On Error Resume Next
    Dim hFile As Long
    Dim arrBytes() As Byte
    Dim lFlags As Long
    Dim lRet As Long
    
    Err.Clear
    
    If m_Overwrite Then lFlags = CREATE_ALWAYS Else lFlags = OPEN_EXISTING
    
    hFile = CreateFile(m_FileName, GENERIC_READ Or GENERIC_WRITE, _
    FILE_SHARE_READ Or FILE_SHARE_WRITE, ByVal 0&, lFlags, _
    FILE_ATTRIBUTE_NORMAL, ByVal 0&)
    
    If Not m_Overwrite Then
        If PosFrom = -1 Then
            SetFilePointer hFile, 0, 0, FILE_END
        Else
            SetFilePointer hFile, PosFrom, 0, FILE_BEGIN
        End If
    End If
    arrBytes = StrConv(OutData, vbFromUnicode)
    WriteFile hFile, arrBytes(0), UBound(arrBytes) + 1, lRet, ByVal 0&
    CloseHandle hFile
    
    If CheckError And CheckAttach And CheckNfo Then
        m_Nfo.Status = stErr
        m_Nfo.Kind = IIf(IsVBErr, kdVB, kdApi)
        m_Nfo.Number = IIf(m_Nfo.Kind = kdApi, Err.LastDllError, Err.Number)
        m_Nfo.Description = Err.Description
        m_Attach.SetErrorInfo m_Nfo
        Err.Clear
    End If
    
    
End Function

'     OutByte   PosFrom
Public Function O_Bytes(OutData() As Byte, Optional PosFrom As Long = -1)
On Error Resume Next
    Dim hFile As Long
    Dim arrBytes() As Byte
    Dim lFlags As Long
    Dim lRet As Long
    
    Err.Clear
    
    If m_Overwrite Then lFlags = CREATE_ALWAYS Else lFlags = OPEN_EXISTING
    
    hFile = CreateFile(m_FileName, GENERIC_READ Or GENERIC_WRITE, _
    FILE_SHARE_READ Or FILE_SHARE_WRITE, ByVal 0&, lFlags, _
    FILE_ATTRIBUTE_NORMAL, ByVal 0&)
    
    If Not m_Overwrite Then
        If PosFrom = -1 Then
            SetFilePointer hFile, 0, 0, FILE_END
        Else
            SetFilePointer hFile, PosFrom, 0, FILE_BEGIN
        End If
    End If
    WriteFile hFile, OutData(0), UBound(OutData) + 1, lRet, ByVal 0&
    CloseHandle hFile
    
    If CheckError And CheckAttach And CheckNfo Then
        m_Nfo.Status = stErr
        m_Nfo.Kind = IIf(IsVBErr, kdVB, kdApi)
        m_Nfo.Number = IIf(m_Nfo.Kind = kdApi, Err.LastDllError, Err.Number)
        m_Nfo.Description = Err.Description
        m_Attach.SetErrorInfo m_Nfo
        Err.Clear
    End If
    
End Function

'      PosFrom
'!
'StructAddr __   VarPtr(_)
'ByteCount __  Len(_) - 
'  
Public Function O_Struct(StructAddr As Long, ByteCount As Long, Optional PosFrom As Long = -1)
On Error Resume Next
    Dim arrB() As Byte
    ReDim arrB(ByteCount - 1)
    CopyMemoryRef arrB(0), StructAddr, ByteCount
    O_Bytes arrB, PosFrom
End Function
